## snek 1.1

=== Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = .

include snek-install.defs

SNEK_OTHEROS?=1
ifeq ($(SNEK_OTHEROS),1)
SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx
endif

SUBDIRS = snekde doc examples $(SNEK_OTHEROS_DIR)

SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)

all: $(SNEKS)
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)); done

$(SNEKS): FORCE
	+cd `dirname $@` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)

FORCE:

check: all
	+cd test && make $@

SHAREFILES = \
	snek.defs \
	$(SNEK_SRC) \
	$(SNEK_EXT_SRC) \
	$(SNEK_RAW_INC) \
	$(SNEK_EXT_INC) \
	$(SNEK_BUILTINS) \
	$(SNEK_EXT_BUILTINS) \
	$(SNEK_ROOT)/snek-gram.ll \
	$(SNEK_ROOT)/snek-builtin.py

IMAGEFILES = \
	snek.svg

DOCFILES = \
	$(IMAGEFILES)

PKGFILES = \
	snek.pc

install: $(SHAREFILES) $(PKGFILES) $(DOCFILES)
	install -d $(DESTDIR)$(SHAREDIR)
	for i in $(SHAREFILES); do install --mode=644 "$$i" $(DESTDIR)$(SHAREDIR); done
	install -d $(DESTDIR)$(PKGCONFIG)
	for i in $(PKGFILES); do install --mode=644 "$$i" $(DESTDIR)$(PKGCONFIG); done
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR); done
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done

upload:
	+cd doc && make upload
	for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done

snek.pc: snek.pc.in
	$(SNEK_SED) $^ > $@

snek-mu.py:
	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@

clean:
	rm -f snek.pc
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done

=== doc/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=snek.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css coderay-asciidoctor.css
IMAGE_FILES=../snek.svg

all: $(HTML_FILES) $(PDF_FILES)

BOOK_FILES=snek-book.pdf snek-cover.pdf snek-book-book.pdf snek-cover-book.pdf

book: $(BOOK_FILES)

LETTER_ATTRIBUTES=--attribute='pdf-style=snek' 
BOOK_ATTRIBUTES=--attribute='pdf-style=snek-book' 
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v -B$(SNEK_ROOT) $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf -B$(SNEK_ROOT) $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): snek-theme.yml $(IMAGE_FILES)

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES)

install: $(DOCFILES)
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR); done

snek-book.pdf: snek.adoc snek-book-theme.yml
	asciidoctor-pdf -o `pwd`/$@ -B$(SNEK_ROOT) $(ATTRIBUTES) $(BOOK_ATTRIBUTES) snek.adoc

snek-book-book.pdf: snek-book.pdf
	pdfbook2 -n --paper=letter snek-book.pdf

snek-cover.pdf: snek-cover.svg
	rsvg-convert -d 72 -p 72 -f pdf -o $@ $^

snek-cover-book.pdf: snek-cover.svg
	rsvg-convert -d 69.05 -p 69.94 -f pdf -o $@ $^

upload: $(DOCFILES)
	rsync -avz $(DOCFILES) fonts $(SNEKDOC)

clean::
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES) coderay-asciidoctor.css

=== examples/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = ..

include $(SNEK_ROOT)/snek-install.defs

all:
	echo all done

EXAMPLES = \
	blink.py \
	hanoi.py \
	morse.py \
	snek-bsd.py \
	snek.py \
	track-light.py \
	badshuffle.py \
	goodshuffle.py

install:
	install -d "$(DESTDIR)$(EXAMPLEDIR)"
	for example in $(EXAMPLES); do install -m 0644 "$$example" "$(DESTDIR)$(EXAMPLEDIR)"; done

=== snekde/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

all: snekde snekde.desktop

%:
	@echo done $@

install: snekde snekde.desktop snekde.1
	install -d $(DESTDIR)$(BINDIR)
	install snekde $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(APPDIR)
	install snekde.desktop $(DESTDIR)$(APPDIR)
	install -d $(DESTDIR)$(ICONDIR)
	install -m 644 ../snek.svg $(DESTDIR)$(ICONDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install snekde.1 $(DESTDIR)$(MANDIR)/man1

snekde.desktop: snekde.desktop.in
	$(SNEK_SED) $^ > $@

snekde: snekde.py
	cp $^ $@
	chmod +x $@

clean::
	rm -f snekde snekde.desktop

=== test/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=..

include $(SNEK_ROOT)/snek.defs

SNEK?=$(SNEK_PORTS)/posix/snek

SUCCESS_TESTS = \
	andor.py \
	list.py \
	dict.py \
	equal_is.py \
	float.py \
	for-array.py \
	for-range.py \
	for-string.py \
	for-break.py \
	for-nested.py \
	global.py \
	if.py \
	math.py \
	op.py \
	range.py \
	slice.py \
	while.py \
	while-break.py \
	while-else.py \
	scoping-global.py \
	scoping-local.py \
	none.py \
	args.py \
	assert-success.py

FAIL_TESTS = \
	scoping-no-decl.py \
	list-named.py \
	tuple-named.py \
	range-named.py \
	formal-named-first.py \
	actual-named-first.py \
	args-missing.py \
	arg-dup1.py \
	arg-dup2.py \
	arg-unknown.py \
	assert-fail.py

check:
	@exit=0; \
	for TEST in $(SUCCESS_TESTS); do \
		echo "Running test $$TEST."; \
		if python3 $$TEST; then \
			echo "    python pass"; \
		else \
			echo "    ***************** python fail *********************"; \
			exit=1; \
		fi; \
		if $(SNEK) $$TEST; then \
			echo "    snek pass"; \
		else \
			echo "    ***************** snek fail ***********************"; \
			exit=1; \
		fi; \
	done; \
	for TEST in $(FAIL_TESTS); do \
		echo "Running test $$TEST."; \
		python3 $$TEST 2>/dev/null; \
		if [ $$? -eq 1 ]; then \
			echo "    python pass"; \
		else \
			echo "    ***************** python fail *********************"; \
			exit=1; \
		fi; \
		$(SNEK) $$TEST 2>/dev/null; \
		if [ $$? -eq 1 ]; then \
			echo "    snek pass"; \
		else \
			echo "    ***************** snek fail ***********************"; \
			exit=1; \
		fi; \
	done; \
	exit $$exit

=== hosts/linux/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

LINUX_DIST=snek-linux-$(SNEK_VERSION).tar.bz2
LINUX_SH=snek-linux-$(SNEK_VERSION).sh
DESKTOP_FILES=$(SNEK_PORTS)/posix/snek.desktop.in $(SNEK_ROOT)/snekde/snekde.desktop.in

PROGS= \
	$(SNEK_PORTS)/posix/snek \
	$(SNEK_ROOT)/snekde/snekde \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.in \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.in \
	$(SNEK_PORTS)/mega/snek-mega-install.in

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(SNEK_ROOT)/doc/snek.pdf \
	$(SNEK_ROOT)/snekde/snekde.1 \
	$(SNEK_ROOT)/COPYING \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.1 \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.1 \
	$(SNEK_PORTS)/mega/snek-mega-install.1

LINUX_FILES=$(PROGS) $(DESKTOP_FILES) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(LINUX_SH)

$(LINUX_SH): $(LINUX_DIST) linux-install.sh
	cat linux-install.sh $(LINUX_DIST) > $@
	chmod +x $@

linux-install.sh: linux-install.sh.in
	$(SNEK_SED) $^ > $@

$(LINUX_DIST): $(LINUX_FILES) $(LINUX_EXTRA)
	-rm -f $@
	-rm -rf linux
	mkdir -p linux/Snek
	cp -a $(LINUX_FILES) linux/Snek
	tar cjf $@ -C linux Snek

upload: $(LINUX_SH)
	rsync -avz $(LINUX_SH) $(SNEKDIST)

clean:
	rm -f snek-*.sh *.bz2
	rm -rf linux

=== hosts/macosx/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../..

include $(SNEK_ROOT)/snek-install.defs

MACOSX_RES=16 32 128 256 512
MACOSX_ICON_PNGS = $(shell for i in $(MACOSX_RES); do echo snek-$$i.png; done)
MACOSX_ICON = snek.icns
MACOSX_DIST = snek-mac-$(SNEK_VERSION).dmg

SNEKDE = $(SNEK_ROOT)/snekde/snekde.py
SNEKDE_SCRIPTS = runsnekde snekde-script
SNEKDE_FILES = $(SNEKDE_SCRIPTS) snekde-Info.plist $(SNEKDE)

ifneq ($(strip $(SNEKMAC)),)
SNEK = snek
SNEK_SCRIPTS =  runsnek snek-script
SNEK_FILES = $(SNEK_SCRIPTS) snek-Info.plist $(SNEK)
endif

MACOSX_INSTALL = install-macosx

MACOSX_DOCS = $(SNEK_ROOT)/doc/snek.pdf $(SNEK_ROOT)/COPYING ReadMe-Mac.rtf

MACOSX_FILES=$(SNEKDE_FILES) $(SNEK_FILES) serial $(MACOSX_ICON) $(MACOSX_SCRIPTS) $(MACOSX_INSTALL) $(MACOSX_DOCS) $(SNEK_ROOT)/examples/*.py

all: $(MACOSX_DIST)

$(MACOSX_ICON): $(SNEK_ROOT)/snek.svg
	for i in $(MACOSX_RES); do rsvg-convert -w $$i -h $$i -o snek-$$i.png $^; done
	png2icns $@ $(MACOSX_ICON_PNGS)

macosx: $(MACOSX_FILES)
	rm -rf macosx
	mkdir -p macosx/examples

ifeq ($(strip $(SNEKMAC)),)
snek-bits:
	echo 'no snek app'
else
snek-bits: $(SNEK_FILES) macosx
	#
	# snek
	#
	mkdir -p macosx/snek.app/Contents/Resources macosx/snek.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snek.app/Contents/PkgInfo
	cp -p snek-Info.plist macosx/snek.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snek.app/Contents/Resources
	cp -a $(SNEK) macosx/snek.app/Contents/Resources
	cp -p $(SNEK_SCRIPTS) macosx/snek.app/Contents/MacOS/
endif

$(MACOSX_DIST): $(MACOSX_FILES) macosx
	rm -f $@
	cp -a $(MACOSX_DOCS) macosx
	cp -a $(MACOSX_INSTALL) macosx
	cp -a $(FIRMWARE) macosx
	cp -a $(USBFIRMWARE) macosx
	cp -a $(SNEK_ROOT)/examples/* macosx/examples
	#
	# snekde
	#
	mkdir -p macosx/snekde.app/Contents/Resources macosx/snekde.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snekde.app/Contents/PkgInfo
	cp -p snekde-Info.plist macosx/snekde.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snekde.app/Contents/Resources
	cp -a $(SNEKDE) macosx/snekde.app/Contents/Resources
	cp -a serial macosx/snekde.app/Contents/Resources
	cp -p $(SNEKDE_SCRIPTS) macosx/snekde.app/Contents/MacOS/
	#
	# generate iso image
	#
	genisoimage -D -V Snek-$(SNEK_VERSION) -no-pad -r -apple -o $@ macosx

serial: always
	rsync -a --delete --delete-excluded --exclude '__pycache__' --exclude '*.pyc' /usr/lib/python3/dist-packages/serial/ serial

always:

snekde-Info.plist: snekde-Info.plist.in
	$(SNEK_SED) $^ > $@

snek-Info.plist: snek-Info.plist.in
	$(SNEK_SED) $^ > $@

$(SNEK): FORCE
	./build-mac $(SNEKMAC) $@

FORCE:

install:
	echo install done

upload: $(MACOSX_DIST)
	rsync -avz $(MACOSX_DIST) $(SNEKDIST)

clean:
	rm -rf serial
	rm -rf snek
	rm -f $(MACOSX_ICON) $(MACOSX_ICON_PNGS)
	rm -f snekde-Info.plist snek-Info.plist
	rm -rf macosx *.dmg

=== hosts/windows/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-windows.c \
	$(SNEK_ROOT)/snek-math.c

SNEK_LOCAL_INC = snek-windows.h
SNEK_LOCAL_BUILTINS = snek-windows.builtin $(SNEK_ROOT)/snek-math.builtin

INF=altusmetrum.inf
WINDOWS_FILES=snek.exe snek.ico snekde.py $(SNEK_ROOT)/doc/snek.pdf $(SNEK_ROOT)/examples $(SNEK_ROOT)/COPYING $(FIRMWARE) $(USBFIRMWARE) $(INF)

include $(SNEK_ROOT)/snek-install.defs

WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe

CC=i686-w64-mingw32-gcc
MINGFLAGS=-Wall -Wextra -mconsole

OPT=-O0

CFLAGS=$(OPT) -g -I. $(SNEK_CFLAGS) $(MINGFLAGS)

LIBS=-lm

all: $(WINDOWS_INSTALL)

$(WINDOWS_INSTALL): $(WINDOWS_FILES) snek.cfg
	pynsist snek.cfg

snek.cfg: snek.cfg.in $(SNEK_ROOT)/snek-install.defs $(SNEK_ROOT)/snek.defs
	for i in $(FIRMWARE); do echo "	$$i"; done | sed '/@SNEK_FIRMWARE@/r /dev/stdin' snek.cfg.in | sed '/@SNEK_FIRMWARE/d' | $(SNEK_SED) > $@

snek.exe: $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

vpath %.svg $(SNEK_ROOT)

snekde.py: $(SNEK_ROOT)/snekde/snekde.py
	cp $^ $@

.SUFFIXES: .svg .build .icns .ico .rc .o .exe

.svg.build:
	for i in $(RES); do rsvg-convert -w $$i -h $$i -o $*-$$i.png $^; done && touch $@

.build.ico:
	icotool -c -o $@ $(shell for i in $(RES); do echo $*-$$i.png; done)

.ico.rc:
	./make-rc "$*" $(VERSION) > $@

RES=16 24 32 48 64 72 96 128 180 256

install:
	echo install done

upload: $(WINDOWS_INSTALL)
	rsync -avz $(WINDOWS_INSTALL) $(SNEKDIST)

clean::
	rm -f snek.exe snek.ico snekde.py snek.cfg snek-*.png
	rm -rf build

=== ports/crickit/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-crickit
PRODUCT_NAME=SnekCrickit
IDPRODUCT=0x002c
IDVENDOR=0xfffe

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-crickit.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install:
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/duemilanove/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

SNEK_ASSERT = 0

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-duemilanove.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-duemilanove.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-duemilanove-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x8000 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x7a0 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x400 \
	-Wl,-Map=$(MAP)

ISP = usbtiny
#ISP = avrisp2

#
# lfuse: 0xff
#	CKDIV8:		1	no divide by 8
#	CKOUT:		1	no clock output
#	SUT1:		1	crystal osc, slow startup
#	SUT0:		1	crystal osc, slow startup
#	CKSEL3:		1	low swing osc, 8-16MHz
#	CKSEL2:		1	low swing osc, 8-16MHz
#	CKSEL1:		1	low swing osc, 8-16MHz
#	CKSEL0:		1	crystal osc
# hfuse:
#	RSTDISBL:	1	reset enabled
#	DWEN:		1	debug wire disabled
#	SPIEN:		0	SPI program enabled
#	WDTON:		1	watch dog disabled
#	EESAVE:		0	EEPROM saved across chip erase
#	BOOTSZ1:	1	256 words
#	BOOTSZ0:	1	256 words
#	BOOTRST:	1	boot to address 0
# efuse:
#	BODLEVEL2	1	brown out 2.5-2.9V
#	BODLEVEL1	0	brown out 2.5-2.9V
#	BODLEVEL0	1	brown out 2.5-2.9V

all: $(HEX) snek-duemilanove-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-duemilanove-install: snek-duemilanove-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

set-fuse:
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U lfuse:w:0xff:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U hfuse:w:0xd7:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U efuse:w:0xfd:m

load: $(HEX) snek-duemilanove-install
	./snek-duemilanove-install -isp $(ISP) -hex $(HEX) load

install: snek-duemilanove-install $(HEX) snek-duemilanove-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-duemilanove-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-duemilanove-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf *.hex *.map snek-duemilanove-install

=== ports/feather/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-feather
PRODUCT_NAME=SnekFeather
IDPRODUCT=0x8022
IDVENDOR=0x239A

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-feather.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install:
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/itsybitsy3v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

PROGNAME=snek-itsybitsy3v
PRODUCT_NAME=SnekItsyBitsy3v

AVR_CLOCK=8000000UL

SNEK_ASSERT = 0

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	snek-itsybitsy3v.builtin

include $(SNEK_ROOT)/snek-install.defs

all: $(ELF) $(HEX)

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

$(SNEK_OBJ): $(SNEK_INC)

distclean: clean

clean::
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

install: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

uninstall:

ISP=avrisp2

load: $(HEX) ../itsybitsy5v/snek-itsybitsy-install
	../itsybitsy5v/snek-itsybitsy-install -quick -isp $(ISP) -hex $(HEX) load

=== debian/changelog ===
snek (1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change source-only upload to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Thu, 24 Oct 2019 23:49:18 -0400

snek (1.1-1) unstable; urgency=medium

  * Upstream release 1.1
  * Add copyright information for fonts
  * Switch copyright on docs to GPLv3+ (from CC SA)
  * Add copyright information for uf2conf.py
  * Add copyright information for Instdrv
  * Make named vs positional parameters match Python
  * Add 'None' built-in constant
  * Add 'SnekBoard' port
  * Add string * number
  * Add 'assert' statement (from Paulo Henrique Silva <ph.silva@carta.com>)

 -- Keith Packard <keithp@keithp.com>  Thu, 12 Sep 2019 15:58:41 -0400

snek (1.0-2) unstable; urgency=medium

  * Update debian/copyright.

 -- Keith Packard <keithp@keithp.com>  Sun, 09 Jun 2019 19:04:03 -0700

snek (1.0-1) unstable; urgency=medium

  * First production upstream release (1.0)
  * ItsyBitsy 3v support
  * ItsyBitsy M0 support
  * APA102 driver
  * Fix op= when global var in scope
  * Reset parser/lexer at end of EEPROM loading
  * Add page-up/page-down support in snekde

 -- Keith Packard <keithp@keithp.com>  Fri, 07 Jun 2019 20:01:33 -0700

snek (0.98-1) unstable; urgency=medium

  * 0.98 upstream release
  * Arduino Mega port
  * Circuit Playground Express port
  * ItsyBitsy port
  * NeoPixel driver

 -- Keith Packard <keithp@keithp.com>  Mon, 20 May 2019 16:56:09 -0700

snek (0.97-1) unstable; urgency=medium

  * 0.97 upstream release
  * Crickit FeatherWing port
  * Port names

 -- Keith Packard <keithp@keithp.com>  Mon, 22 Apr 2019 12:43:16 -0700

snek (0.96-1) unstable; urgency=medium

  * 0.96 upstream release
  * Lots of doc updates
  * Ship snek binary and firwmare for mac os x
  * Include math functions on Windows binary

 -- Keith Packard <keithp@keithp.com>  Wed, 17 Apr 2019 15:03:28 -0700

snek (0.95-1) unstable; urgency=medium

  * 0.95 upstream release
  * Ensure dictionary keys are completely immutable
  * Generate error for int operations on floats which aren't exactly int
  * Update docs after review by Mike Ward

 -- Keith Packard <keithp@keithp.com>  Fri, 12 Apr 2019 20:23:06 -0700

snek (0.94-1) unstable; urgency=medium

  * 0.94-1
  * Fix SAMD21 GPIO pincfg computation. GPIOs were not working right.

 -- Keith Packard <keithp@keithp.com>  Thu, 11 Apr 2019 23:46:14 -0700

snek (0.93-1) unstable; urgency=medium

  * 0.93-1
  * Fix SAMD21 USB driver INT endpoint HW configuration.
  * Provide tutorial instructions for GPIO functions
  * Document snekde in snek.pdf
  * Expand per-board documentation

 -- Keith Packard <keithp@keithp.com>  Thu, 11 Apr 2019 21:27:59 -0700

snek (0.92-1) unstable; urgency=medium

  * 0.92-1
  * Get snek-duino-install working
  * Fix ADC input for metro-snek

 -- Keith Packard <keithp@keithp.com>  Sat, 30 Mar 2019 19:06:36 -0700

snek (0.91-1) unstable; urgency=medium

  * Version 0.91
  * Math functions added to metro-snek and host snek
  * Fix USB input queue bug on metro-snek
  * Get snekde working with metro-snek

 -- Keith Packard <keithp@keithp.com>  Wed, 27 Mar 2019 10:11:13 -0700

snek (0.9-1) unstable; urgency=medium

  * Version 0.9
  * Metro-M0 express port

 -- Keith Packard <keithp@keithp.com>  Sun, 24 Mar 2019 19:17:49 -0700

snek (0.8-1) unstable; urgency=medium

  * Version 0.8

 -- Keith Packard <keithp@keithp.com>  Mon, 04 Mar 2019 22:51:51 -0800

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Build-Depends: debhelper (>= 12), libreadline-dev, avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, libnewlib-nano-arm-none-eabi,
 python3, lola, gawk, asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
Standards-Version: 4.4.0

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes a binary for that target, the
 snek-duino-install tool for installing Snek on Arduino boards, the
 snekde integrated development environment

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export SNEK_OTHEROS=0
export PREFIX=/usr
export OPT=-O2

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip -X.elf

=== debian/tests/control ===
Test-Command: make SNEK=snek -C test check

## snek 1.2

=== Makefile ===
--- 
+++ 
@@ -67,9 +67,13 @@
 	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
 	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
 
-upload:
+upload: $(SNEKS)
 	+cd doc && make upload
-	for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done
+
+otheros: $(SNEKS)
+	+cd doc && make
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done
 
 snek.pc: snek.pc.in
 	$(SNEK_SED) $^ > $@

=== test/Makefile ===
--- 
+++ 
@@ -31,6 +31,7 @@
 	for-nested.py \
 	global.py \
 	if.py \
+	int.py \
 	math.py \
 	op.py \
 	range.py \

=== ports/duemilanove/Makefile ===
--- 
+++ 
@@ -15,13 +15,12 @@
 SNEK_ROOT = ../..
 SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
 
-SNEK_ASSERT = 0
-
 include $(SNEK_ATMEGA)/snek-atmega.defs
 
 SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)
 
 SNEK_LOCAL_SRC = \
+	snek-pow.c \
 	snek-duemilanove.c \
 	$(SNEK_ATMEGA_SRC)

=== ports/itsybitsy3v/Makefile ===
--- 
+++ 
@@ -19,8 +19,6 @@
 PRODUCT_NAME=SnekItsyBitsy3v
 
 AVR_CLOCK=8000000UL
-
-SNEK_ASSERT = 0
 
 include $(SNEK_AVR)/snek-avr.defs

=== ports/itsybitsy5v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

PROGNAME=snek-itsybitsy5v
PRODUCT_NAME=SnekItsyBitsy5v

AVR_CLOCK=16000000UL

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	snek-itsybitsy5v.builtin

include $(SNEK_ROOT)/snek-install.defs

all: $(ELF) $(HEX) snek-itsybitsy-install

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-itsybitsy-install: snek-itsybitsy-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install:: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

install:: snek-itsybitsy-install snek-itsybitsy-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-itsybitsy-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-itsybitsy-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek-itsybitsy-install
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

uninstall::

ISP=avrisp2

load: $(HEX) snek-itsybitsy-install
	./snek-itsybitsy-install -quick -isp $(ISP) -hex $(HEX) load

=== ports/mega/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c \
	snek-mega.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-math.builtin \
	snek-input.builtin \
	snek-mega.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

USBSERIAL_HEX=Arduino-usbserial-atmega16u2-Mega2560-Rev3.hex

BASE=snek-mega-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc
CFLAGS=-Os -DF_CPU=16000000UL -mmcu=atmega2560 -I. -I$(SNEK_LOCAL_VPATH) -g -fno-jump-tables $(SNEK_CFLAGS) -mcall-prologues -Waddr-space-convert
LDFLAGS=-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x3e000 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x1e00 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x1000 \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyACM0

all: $(HEX) snek-mega-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@awk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-mega-install: snek-mega-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-mega-install
	./snek-mega-install -port $(PORT) -hex $(HEX)

install: snek-mega-install $(HEX) snek-mega-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-mega-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(USBSERIAL_HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-mega-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-mega-install

load-direct: $(HEX)
	avrdude -patmega2560 -cwiring -P/dev/ttyACM0 -b115200 -D -Uflash:w:$(HEX):i

=== ports/nano33iot/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-nano33iot
PRODUCT_NAME=SnekNano33iot
IDPRODUCT=0x8057
IDVENDOR=0x2341

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-nano33iot.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

upload: $(BIN)
	bossac -e -w -v -b -R $(BIN)

install:
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/posix/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-main.c \
	snek-posix.c \
	snek-math.c \
	snek-curses.c \
	snek-input.c

SNEK_LOCAL_INC = snek-posix.h
SNEK_LOCAL_BUILTINS = snek-posix.builtin $(SNEK_ROOT)/snek-math.builtin $(SNEK_ROOT)/snek-input.builtin

include $(SNEK_ROOT)/snek-install.defs

OPT?=-O3

CFLAGS+=-DSNEK_MEM_INCLUDE_NAME $(OPT) -g -I. $(SNEK_CFLAGS) -Werror $(CPPFLAGS)

LIBS=-lreadline -lm

all: snek snek.desktop

snek: $(SNEK_OBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

install: snek snek.1
	install -d $(DESTDIR)$(BINDIR)
	install snek $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(APPDIR)
	install snek.desktop $(DESTDIR)$(APPDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install snek.1 $(DESTDIR)$(MANDIR)/man1

snek.desktop: snek.desktop.in
	$(SNEK_SED) $^ > $@


clean::
	rm -f snek snek.desktop

=== ports/qemu-arm/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_QEMU = $(SNEK_ROOT)/chips/qemu

ARCH = arm-none-eabi
ARCH_CFLAGS = -mlittle-endian -mcpu=cortex-m3 -mthumb 
PROGNAME = snek-qemu-arm

include $(SNEK_QEMU)/snek-qemu.defs

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) run-arm

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-Tsnek-qemu-arm.ld -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)

run-arm: run-arm.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

uninstall:

clean::
	rm -f run-arm

=== ports/qemu-riscv/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_QEMU = $(SNEK_ROOT)/chips/qemu

ARCH = riscv64-unknown-elf
ARCH_CFLAGS = -march=rv32imac -mabi=ilp32
PROGNAME = snek-qemu-riscv

include $(SNEK_QEMU)/snek-qemu.defs

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) run-riscv

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-Tsnek-qemu-riscv.ld -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)

run-riscv: run-riscv.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

uninstall:

=== ports/snekboard/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-board
PRODUCT_NAME=snekboard
IDPRODUCT=0x804D
IDVENDOR=0x239A

BOOTLOADER_BIN=bootloader-snekboard-v3.7.0.bin

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-board.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) $(BIN) $(UF2) snek-board-install

$(PROG): Makefile $(OBJ) $(SNEK_SAMD21)/snek-samd21.ld
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)*.elf $(PROGNAME)*.bin $(PROGNAME)*.uf2 $(PROGNAME)*.map ao-product.h
	rm -f snek-board-install

snek-board-install: snek-board-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

echo:
	echo PROG is $(PROG)

install: $(PROG) $(UF2) $(BOOTLOADER_BIN) snek-board-install snek-board-install.1
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(BOOTLOADER_BIN) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-board-install.1 $(DESTDIR)$(MANDIR)/man1

uninstall:

=== debian/changelog ===
snek (1.2-2) unstable; urgency=medium

  * Expose compiler flags in build log
  * Add dpkg-buildflags to Linux snek binary

 -- Keith Packard <keithp@keithp.com>  Fri, 15 Nov 2019 23:30:08 -0800

snek (1.2-1) unstable; urgency=medium

  * Upstream release 1.2
  * Switch from newlib-nano to picolibc (tracking upstream change)
  * Add PEP-515 support (thanks to Paulo Henrique Silva <ph.silva@carta.com>)
  * Improve clock setup on snekboard to make USB happier.
  * Add QEMU ports for ARM and RISC-V
  * Add support for Arduino Nano 33 IoT board

 -- Keith Packard <keithp@keithp.com>  Fri, 15 Nov 2019 16:07:29 -0800

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Keith Packard <keithp@keithp.com>
 Homepage: https://keithp.com
 Build-Depends: debhelper (>= 12), libreadline-dev, avr-libc, gcc-avr,
- binutils-arm-none-eabi, gcc-arm-none-eabi, libnewlib-nano-arm-none-eabi,
+ binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.1),
+ binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.1),
  python3, lola, gawk, asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
 Standards-Version: 4.4.0

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export SNEK_OTHEROS=0
export PREFIX=/usr
export OPT=$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS)
export V=1

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip -X.elf

override_dh_dwz:
	dh_dwz -X.elf
